#ifndef __CALLBACKS_H__
#define __CALLBACKS_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <pango/pango.h>
#include <fcntl.h>
#include <glib.h>
#include <dlfcn.h>
#include <postgresql/libpq-fe.h>
#include <pwd.h>
#include <unistd.h>
#include <errno.h>
#include <time.h>
#include <locale.h>
#include <getopt.h>
#include <math.h>


#include "modules/common/xdfPQexec/xdfPQexec.h"
#include "modules/common/xdfLog/xdfLog.h"
/*
#include "config.h"
#include "modules/common/xdfDialogMsg/xdfDialogMsg.h"
#include "modules/common/fix5/libfix5.h"
#include "modules/common/search/search.h"
#include "modules/common/createInvoice/createInvoice.h"
#include "modules/common/invoiceTax/invoiceTax.h"
#include "modules/common/inWords/inWords.h"
#include "modules/common/calcPrices/calcPrices.h"
#include "modules/common/xdfAtof/xdfAtof.h"
#include "modules/common/xdfPQexec/xdfPQexec.h"
*/

/* Menu */
#define MENU_1 "Główne"
#define MENU_2 "Funkcje"
#define MENU_3 "Pomoc"

/* ??? */
#define ENTRY_GET_TEXT(entry) gtk_entry_get_text(GTK_ENTRY(entry))
#define ENTRY_SET_TEXT(a,b) gtk_entry_set_text(GTK_ENTRY(a), b)

/* Typy danych. */

/**
 * Typ danych w ktrym przechowywane s dane wczytane z konfiguracji.
 */
typedef struct 
{
	gchar		conf_path[256];
	gchar		db_name[256];
	gchar		db_host[256];
	gchar		db_port[256];
	gchar		db_user[256];
	gchar		db_password[256];
	gchar		sp_nazwa_firmy[256];
	gchar		sp_wlasciciel[256];
	gchar		sp_kod_pocztowy[256];
	gchar		sp_miejscowosc[256];
	gchar		sp_miejsce_wystawienia[256];
	gchar		sp_telefon[256];
	gchar		sp_fax[256];
	gchar		sp_komorka[256];
	gchar		sp_bank[256];
	gchar		sp_nr_konta[256];
	gchar		sp_ulica[256];
	gchar		sp_nip[256];
	gchar		sp_email[256];
	gchar		sp_www[256];
	gchar		xdf_invoices_clients_clist[256];
	gchar		xdf_invoices_goods_clist[256];
	gchar		xdf_prefix_nr_invoices[256];
	gchar		xdf_kind_of_nr_invoices[256];
	gchar		xdf_info_text[256];
	gchar		xdf_print_command[256];
	gchar		xdf_print_format[256];
	gchar		xdf_goods_prices[256];
	gchar		xdf_ip[256];
} configData;

extern configData conf_params;


/*
 *	Typ danych z obliczonymi wszelkimi kwotami
 *	
 */
typedef struct
{
	double          cena_netto;
	double          cena_brutto;
	double          wartosc_netto;
	double          wartosc_brutto;
	double          kwota_vat;
} prices;

/* Typy danych dla funkcji z invoiceTax */
typedef double Tax;

typedef struct {
		    Tax value_without_tax[5];
			   Tax value_with_tax[5];
} InvoiceTax;

/* ??? */
typedef struct
{
	PGconn *conn;
	int connect;
	int userID;
	int id_goods;
	int row_buy;
	int clients_row;
	int gets_row;
	GtkWidget *entry_search_nip;
	int invoiceNr;
	GString *invoice_number;
	GString *invoice_prefix;
	GtkWidget *widget;
	GtkWidget *widget_destroy;
} xdfInvConnModule;

/* Funkcje */

/* ??? */
int xdfLogBehaviour (char *msg);


/**
	Funkcja ma sprawdzi�czy zosta ustawiony parametr -D | -conf_path i
	jeli tak ustawi�globaln zmienn, z ktrej korzysta nast�nie
	funkcja odczytujca konfiguracj�z plikw.

	@param configData -  zmienna ktrej zostan przypisane przeczytane dane.
*/
void read_conf_path(int argc, char **argv, configData *conf_params);
		  
/**
	Funkcja do pobierania parametrw bazy danych z pliku konfiguracyjnego 
	defactora.
	@param configData	-	zmienna ktrej zostan przypisane przeczytane dane.

  	@return int - jeli wynik jest != 0 oznacza to, e nie udao si�poprawnie
	odczyta�konfiguracji
*/
void read_fileopt(configData *conf_params);

/**
	Funkcja do pobierania parametrw z command line.
	
	@param argc	-	wiadomo;)
	@param argv	-	rwnie
	@param configData	-	zmienna ktrej zostan przypisane przeczytane dane.
*/
int read_cmdopt(int argc, char **argv, configData *conf_params);

/**
  Funkcja do przeszukiwania wzorcow w plikach konfiguracyjnych.
  @param file_name    - plik do przeszukiwan
  @param model	      - wzorzec ktorego szukamy
  @param result       - tu wpisze sie rezultat przeszukiwania pliku

  Format danych w plikach:
  model=result

  @author Michal Ociepka <M.Ociepka@netsync.pl>
  @version 1.0
*/
void search (char *file_name, char *model, char *result);
/**
 *	Funkcja do konwersji stringu wg ustawionego locale do utf8.
 *	@param str		-	string ktry b�zie konwertowany
 *	
 *	@return char*	-	wynik konwersji
 *	
 */
char *conv_to_utf8(const char *str);
		  
/* moduly */
/*
  Ten modul bedzie ZAWSZE widoczny, bedzie pokazywal autorow
  calego projektu oraz logo. Ten modul jest wkompilowywany 
  standardowo i NIE DA SIE GO WYLACZYC!!
*/
void moduleAuthors ();

typedef struct 
{
  PGconn *conn;
  int connect; //dla wartosci 0 polaczenie OK, w przeciwnym wypadku -1
  int userID; //id uzytkownika, ktory sie zalogowal
  int kind_of_conn; //1 - polacz, 0 - rozlacz
	FILE *fd;
} xdfConnModule;

/**
  Polaczenie z baza danych - PostgreSQL.
  Funkcja w zaleznosci od parametru kind_of_conn laczy sie, lub rozlacza 
  z baza danych. Dane odnosnie polaczenia pobierane sa z pliku zdefiniowanego w makrze DB_CONF.
  @param kind_of_conn  - Rodzaj polaczenia. Parametr moze miec wartosc 0 lub 1.
  Kiedy kind_of_conn ma wartosc 0, wtedy nastepuje polaczenie z baza, kiedy 1 wtedy polaczenie zostaje zerwane. 
  @return kind_of_result  - Funkcja zwraca wartosc 0, gdy zadanie zostalo wykonane poprawnie, -1 gdy nastapil blad.
*/ 
int xdfConnSQL (xdfConnModule *conn_module);

/**
 *   Struktura dla funkcji xdfDialogMsg odpowiedzalna za wyswietlenie
 *   stosownego powiadomienia.
 *   
 *   @param title tytul okna
 *   @param msg wiadomosc do przekazania
 *   @param type typ wiadomosci, zalezny of GTK+ 
 *   (m.in. GTK_MESSAGE_{INFO|WARNING|ERROR|QUESTION)
 *
 */
typedef struct
{
	GString *title;
	GString *msg;
	GtkMessageType type;
}  xdfDialogMsgStruct;

void xdfDisconnect (xdfConnModule *conn_mod);

#endif /* __CALLBACKS_H__ */

