#include "../common/defs.h"

gchar *
demo_find_file (const char *base,
		GError    **err)
{
  g_return_val_if_fail (err == NULL || *err == NULL, FALSE);
  
  if (g_file_test (base, G_FILE_TEST_EXISTS))
    return g_strdup (base);
  else
    {
      char *filename = g_build_filename (DEMOCODEDIR, base, NULL);
      if (!g_file_test (filename, G_FILE_TEST_EXISTS))
	{
	  g_set_error (err, G_FILE_ERROR, G_FILE_ERROR_NOENT,
		       "Cannot find demo data file \"%s\"", base);
	  g_free (filename);
	  return NULL;
	}
      return filename;
    }
}

void moduleAuthors (GtkWidget *fixed_main)
{
  GtkWidget *fixed;
  GtkWidget *label[3];
  GtkWidget *image;
  char *filename;

  fixed = gtk_fixed_new ();

  filename = demo_find_file ("logo.jpg", NULL);

  image = gtk_image_new_from_file (filename);
  g_free (filename);

  label[0] = gtk_label_new (NULL);
    gtk_label_set_markup (GTK_LABEL (label[0]), "<span size=\"large\"> Autor : </span>");
    gtk_fixed_put (GTK_FIXED (fixed), GTK_WIDGET (label[0]), 600, 100);
  label[1] = gtk_label_new (NULL);
    gtk_label_set_markup (GTK_LABEL (label[1]), "<span size=\"large\"> Michał Ociepka </span>");

  label[2] = gtk_label_new ("<armad@linuxindex.pl>");
    gtk_fixed_put (GTK_FIXED (fixed), GTK_WIDGET (label[2]), 620, 160);


  gtk_fixed_put (GTK_FIXED (fixed), GTK_WIDGET (label[1]), 620, 130);
  gtk_fixed_put (GTK_FIXED (fixed), GTK_WIDGET (image), 0, 0);

  gtk_widget_show (fixed);
  gtk_widget_show (label[1]);
  gtk_widget_show (label[0]);
  gtk_widget_show (label[2]);
  gtk_widget_show (image);
  
  gtk_fixed_put (GTK_FIXED (GTK_WIDGET (fixed_main)), GTK_WIDGET (fixed), 0, 0);
}
