#include "loadPreferences.h"
#include "modulePreferences.h"
#include "../../config.h"
#include "../../callbacks.h"
#include <stdio.h>

/**
 *	Funkcja wczytujca konfiguracj programu do zmiennej conf.
 */
gboolean loadPreferences(GtkWidget* widget, gpointer data)
{
	gboolean	wynik=1;

	tab_preferences_entries=*(tabPreferencesEntries *)gtk_object_get_data(GTK_OBJECT(widget),"tabs");

	/*
	 * Ustawiamy na nowo widgety na zakadce Sprzedawca wg zmiennej conf_params. 
	 *
	 */
	gtk_entry_set_text(GTK_ENTRY(tab_preferences_entries.tse.entry_nazwa_firmy),
						 conv_to_utf8(conf_params.sp_nazwa_firmy));
	gtk_entry_set_text(GTK_ENTRY(tab_preferences_entries.tse.entry_wlasciciel),
						 conv_to_utf8(conf_params.sp_wlasciciel));
	gtk_entry_set_text(GTK_ENTRY(tab_preferences_entries.tse.entry_kod_pocztowy),
						 conv_to_utf8(conf_params.sp_kod_pocztowy));
	gtk_entry_set_text(GTK_ENTRY(tab_preferences_entries.tse.entry_miejscowosc),
						 conv_to_utf8(conf_params.sp_miejscowosc));
	gtk_entry_set_text(GTK_ENTRY(tab_preferences_entries.tse.entry_miejsce_wystawienia),
						 conv_to_utf8(conf_params.sp_miejsce_wystawienia));
	gtk_entry_set_text(GTK_ENTRY(tab_preferences_entries.tse.entry_telefon),
						 conv_to_utf8(conf_params.sp_telefon));
	gtk_entry_set_text(GTK_ENTRY(tab_preferences_entries.tse.entry_komorka),
						 conv_to_utf8(conf_params.sp_komorka));
	gtk_entry_set_text(GTK_ENTRY(tab_preferences_entries.tse.entry_bank),
						 conv_to_utf8(conf_params.sp_bank));
	gtk_entry_set_text(GTK_ENTRY(tab_preferences_entries.tse.entry_nr_konta),
						 conv_to_utf8(conf_params.sp_nr_konta));
	gtk_entry_set_text(GTK_ENTRY(tab_preferences_entries.tse.entry_ulica),
						 conv_to_utf8(conf_params.sp_ulica));
	gtk_entry_set_text(GTK_ENTRY(tab_preferences_entries.tse.entry_nip),
						 conv_to_utf8(conf_params.sp_nip));

	/*
	 * Ustawiamy na nowo widgety na zakadce XdeFactor-ng wg zmiennej conf_params. 
	 *
	 */
	
	gtk_spin_button_set_value(
						 GTK_SPIN_BUTTON(tab_preferences_entries.txng.spin_button_invoices_clients_clist),
						 atoi(conf_params.xdf_invoices_clients_clist));
	gtk_spin_button_set_value(
						 GTK_SPIN_BUTTON(tab_preferences_entries.txng.spin_button_invoices_goods_clist),
						 atoi(conf_params.xdf_invoices_goods_clist));
	gtk_entry_set_text(GTK_ENTRY(tab_preferences_entries.txng.entry_prefix_nr_invoices),
						 conv_to_utf8(conf_params.xdf_prefix_nr_invoices));

	if (g_strcasecmp(conf_params.xdf_kind_of_nr_invoices,"NR/YYYY"))
		gtk_option_menu_set_menu(GTK_OPTION_MENU(tab_preferences_entries.txng.optionmenu_kind_of_nr_invoices),
						 GTK_WIDGET(tab_preferences_entries.txng.menuitem_kind_of_nr_invoices_1));
	else if (g_strcasecmp(conf_params.xdf_kind_of_nr_invoices,"NR/MM/YYYY"))
		gtk_option_menu_set_menu(GTK_OPTION_MENU(tab_preferences_entries.txng.optionmenu_kind_of_nr_invoices),
						 GTK_WIDGET(tab_preferences_entries.txng.menuitem_kind_of_nr_invoices_2));
	else if (g_strcasecmp(conf_params.xdf_kind_of_nr_invoices,"YYYY/MM/NR"))
		gtk_option_menu_set_menu(GTK_OPTION_MENU(tab_preferences_entries.txng.optionmenu_kind_of_nr_invoices),
						 GTK_WIDGET(tab_preferences_entries.txng.menuitem_kind_of_nr_invoices_3));
	

	gtk_entry_set_text(GTK_ENTRY(tab_preferences_entries.txng.entry_info_text),
						 conv_to_utf8(conf_params.xdf_info_text));
	gtk_entry_set_text(GTK_ENTRY(tab_preferences_entries.txng.entry_print_command),
						 conv_to_utf8(conf_params.xdf_print_command));

	if (g_strcasecmp(conf_params.xdf_print_format,"ps"))
		gtk_toggle_button_set_active (
						 GTK_TOGGLE_BUTTON (tab_preferences_entries.txng.radiobutton_print_format_ps), FALSE);
	else
		gtk_toggle_button_set_active (
						 GTK_TOGGLE_BUTTON (tab_preferences_entries.txng.radiobutton_print_format_ps), TRUE);
	  
	if (g_strcasecmp(conf_params.xdf_print_format,"txt"))
		gtk_toggle_button_set_active (
						 GTK_TOGGLE_BUTTON (tab_preferences_entries.txng.radiobutton_print_format_ascii), FALSE);
	else
		gtk_toggle_button_set_active (
						 GTK_TOGGLE_BUTTON (tab_preferences_entries.txng.radiobutton_print_format_ascii), TRUE);
	

	if (g_strcasecmp(conf_params.xdf_goods_prices,"netto"))
		gtk_toggle_button_set_active (
						 GTK_TOGGLE_BUTTON (tab_preferences_entries.txng.radiobutton_goods_prices_netto), FALSE);
	else
		gtk_toggle_button_set_active (
						 GTK_TOGGLE_BUTTON (tab_preferences_entries.txng.radiobutton_goods_prices_netto), TRUE);
	  
	if (g_strcasecmp(conf_params.xdf_goods_prices,"brutto"))
		gtk_toggle_button_set_active (
						 GTK_TOGGLE_BUTTON (tab_preferences_entries.txng.radiobutton_goods_prices_brutto), FALSE);
	else
		gtk_toggle_button_set_active (
						 GTK_TOGGLE_BUTTON (tab_preferences_entries.txng.radiobutton_goods_prices_brutto), TRUE);
	
	return wynik;
}


/**
 *	Funkcja wczytujca konfiguracj programu do zmiennej conf.
 */
gboolean loadPreferencesFromFile(configData conf)
{
	/*		  
	FILE	*file;
	gchar	*zm;
	gint	i,j;	
	*/
	gboolean wynik=1;

	/*
	 * Rezerwuj pami na zmienne.
	*/
	/*
	conf->nazwa_firmy		=	gmalloc(256);
	conf->wlasciciel		=	gmalloc(256);
	conf->kod_pocztowy	=	gmalloc(256);
	conf->miejscowosc		=	gmalloc(256);
	*/
	
	/*
	 * Wczytujemy ustawienia.\n");
	*/
	/*
	search(CONFIG_FILE,"nazwa_firmy",conf->nazwa_firmy);
	search(CONFIG_FILE,"wlasciciel",conf->wlasciciel);
	search(CONFIG_FILE,"kod_pocztowy",conf->kod_pocztowy);
	search(CONFIG_FILE,"miejscowosc",conf->miejscowosc);
	*/
	
/**
 * ...
 */

	return wynik;
}

