#include "moduleStores.h"

  GtkWidget *entry_search_name;
  GtkWidget *entry_search_id;
  GtkWidget *entry_name;
  GtkWidget *entry_memo;

  PGresult *res;
  ExecStatusType est;

void updateFromClist (char *text, xdfConnModule *conn_mod)
{
  GtkWidget *widget=NULL;

  ENTRY_SET_TEXT (entry_search_id, text);
  findStoreId (widget, conn_mod);
}
void cleanStore (GtkWidget *widget)
{
  ENTRY_SET_TEXT (entry_search_name, "");
  ENTRY_SET_TEXT (entry_search_id, "");
  ENTRY_SET_TEXT (entry_name, "");
  ENTRY_SET_TEXT (entry_memo, "");
}
void updateStore (GtkWidget *widget, xdfConnModule *conn_mod)
{
  GString *string_query = g_string_new ("query");  
  xdfDialogMsgStruct msg_struct;

  xdfPQexec (conn_mod->conn, "BEGIN;");
  g_string_printf (string_query, "UPDATE stores SET name='%s',memo='%s' WHERE id='%s';", ENTRY_GET_TEXT (entry_name), ENTRY_GET_TEXT (entry_memo), ENTRY_GET_TEXT (entry_search_id));

  res = xdfPQexec (conn_mod->conn, string_query->str);
  est = PQresultStatus (res);

  if (strcmp (PQresStatus (est), "PGRES_COMMAND_OK") == 0){
    msg_struct.type = GTK_MESSAGE_INFO;
    msg_struct.msg = g_string_new ("Właśnie uaktualniłem magazyn \n\n\t XdeFactor-ng"); 
  }else{
    msg_struct.type = GTK_MESSAGE_WARNING;
    msg_struct.msg = g_string_new ("UAKTUALNIENIE MAGAZYNU ZAKOŃCZYŁO SIĘ NIEPOWODZENIEM !! \n SPRÓBUJ POPRAWNIE WYPEŁNIĆ FORMULARZ !!\n\n\t XdeFactor-ng"); 
  }

  xdfPQexec (conn_mod->conn, "COMMIT;");

  xdfDialogMsg (&msg_struct);
  g_string_free (string_query, TRUE);	
}
void removeStore (GtkWidget *widget, xdfConnModule *conn_mod)
{
  GString *string_query = g_string_new ("query");  
  xdfDialogMsgStruct msg_struct;

  g_string_printf (string_query, "DELETE FROM stores WHERE id='%s'", ENTRY_GET_TEXT (entry_search_id));

  res = xdfPQexec (conn_mod->conn, string_query->str);
  est = PQresultStatus (res);

  if (strcmp (PQresStatus (est), "PGRES_COMMAND_OK") == 0){
    msg_struct.type = GTK_MESSAGE_INFO;
    msg_struct.msg = g_string_new ("Właśnie usunąłem magazyn \n\n\t XdeFactor-ng"); 
  }else{
    msg_struct.type = GTK_MESSAGE_WARNING;
    msg_struct.msg = g_string_new ("USUNIĘCIE MAGAZYNU ZAKOŃCZYŁO SIĘ NIEPOWODZENIEM !! \n SPRÓBUJ POPRAWNIE WYPEŁNIĆ FORMULARZ !!\n\n\t XdeFactor-ng"); 
  }

  xdfDialogMsg (&msg_struct);
  g_string_free (string_query, TRUE);	
  
}
void addStore (GtkWidget *widget, xdfConnModule *conn_mod)
{
  GString *string_query = g_string_new ("query");  
  xdfDialogMsgStruct msg_struct;

  msg_struct.title = g_string_new ("Raport operacji na magazynach");
  xdfPQexec (conn_mod->conn, "BEGIN;");

  g_string_printf (string_query, "INSERT INTO stores (name, memo) VALUES ('%s','%s');", ENTRY_GET_TEXT (entry_name), ENTRY_GET_TEXT (entry_memo));

  res = xdfPQexec (conn_mod->conn, string_query->str);
  est = PQresultStatus (res);

  if (strcmp (PQresStatus (est), "PGRES_COMMAND_OK") == 0){
    msg_struct.type = GTK_MESSAGE_INFO;
    msg_struct.msg = g_string_new ("Dodałem nowy magazyn \n\n\t XdeFactor-ng"); 
  }else{
    msg_struct.type = GTK_MESSAGE_WARNING;
    msg_struct.msg = g_string_new ("DODANIE NOWEGO MAGAZYNU ZAKOŃCZYŁO SIĘ NIEPOWODZENIEM !! \n SPRÓBUJ POPRAWNIE WYPEŁNIĆ FORMULARZ !!\n\n\t XdeFactor-ng"); 
  }

  xdfPQexec (conn_mod->conn, "COMMIT;");
  xdfDialogMsg (&msg_struct);
  g_string_free (string_query, TRUE);	
}
void findStoreId (GtkWidget *widget, xdfConnModule *conn_mod)
{
  xdfDialogMsgStruct msg_struct;
  GString *string = g_string_new ("string");
  int i;

  i=0;

  xdfPQexec (conn_mod->conn, "BEGIN;");
  g_string_printf (string, "SELECT name, memo FROM stores WHERE id='%s';", gtk_entry_get_text (GTK_ENTRY (entry_search_id)));
  res = xdfPQexec (conn_mod->conn, string->str);
  msg_struct.title = g_string_new ("Raport poszukiwań magazynu -- XdeFactor-ng");

  if (PQntuples(res) == 0){
    msg_struct.type = GTK_MESSAGE_ERROR;
    msg_struct.msg  = g_string_new ("NIE MA TAKIEGO MAGAZYNU \n\n\t XdeFactor-ng");
    xdfDialogMsg (&msg_struct);
    goto END;
  }
  for (i=0; i < PQntuples (res); i++){
    ENTRY_SET_TEXT (entry_name, PQgetvalue (res, i, 0));
    ENTRY_SET_TEXT (entry_memo, PQgetvalue (res, i, 1));
  }

  END:

  xdfPQexec (conn_mod->conn, "COMMIT;"); 
  
  g_string_free (string, TRUE);  
}
void findStoreName (GtkWidget *widget, xdfConnModule *conn_mod)
{
  xdfDialogMsgStruct msg_struct;
  GString *string = g_string_new ("string");
  int i;

  i=0;

  xdfPQexec (conn_mod->conn, "BEGIN;");
  g_string_printf (string, "SELECT id, name, memo FROM stores WHERE name ILIKE '%%%s%%';",gtk_entry_get_text (GTK_ENTRY (entry_search_name)));

  res = xdfPQexec (conn_mod->conn, string->str);
  msg_struct.title = g_string_new ("Raport poszukiwań magazynu -- XdeFactor-ng");

  if (PQntuples(res) == 0){
    msg_struct.type = GTK_MESSAGE_ERROR;
    msg_struct.msg  = g_string_new ("NIE MA TAKIEGO MAGAZYNU \n\n\t XdeFactor-ng");
    xdfDialogMsg (&msg_struct);
    goto END;
  }
  for (i=0; i < PQntuples (res); i++){
    ENTRY_SET_TEXT (entry_search_id, PQgetvalue (res, i, 0));
    ENTRY_SET_TEXT (entry_name, PQgetvalue (res, i, 1));
    ENTRY_SET_TEXT (entry_memo, PQgetvalue (res, i, 2));
  }

  END:

  xdfPQexec (conn_mod->conn, "COMMIT;"); 
  
  g_string_free (string, TRUE);  
}

void moduleStores (xdfConnModule *conn_mod)
{
  GtkWidget *window_stores;
  GtkWidget *fixed_main;
  GtkWidget *frame_search;
  GtkWidget *fixed2;
  GtkWidget *label1;
  GtkWidget *button_search_name;
  GtkWidget *button_search_id;
  GtkWidget *label2;
  GtkWidget *button_remove;
  GtkWidget *button_add;
  GtkWidget *button_update;
  GtkWidget *button_clean;
  GtkWidget *frame_stores;
  GtkWidget *button_show_clist;
  GtkWidget *fixed3;
  GtkWidget *label4;
  GtkWidget *label3;
  xdfDialogMsgStruct msg_struct;

  if (conn_mod->connect == 0){

  window_stores = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window_stores), "window_stores", window_stores);
  gtk_window_set_title (GTK_WINDOW (window_stores), "Magazyny -- XdeFactor-ng");
  gtk_window_set_position (GTK_WINDOW (window_stores), GTK_WIN_POS_CENTER);
  gtk_window_resize (GTK_WINDOW (window_stores), 495, 310);
  gtk_widget_show (GTK_WIDGET (window_stores));

  fixed_main = gtk_fixed_new ();
  gtk_widget_show (fixed_main);
  gtk_container_add (GTK_CONTAINER (window_stores), fixed_main);

  frame_search = gtk_frame_new ("Szukaj magazynu");
  
  gtk_widget_show (frame_search);
  gtk_fixed_put (GTK_FIXED (fixed_main), frame_search, 8, 8);
  
  gtk_widget_set_usize (frame_search, 480, 52);

  fixed2 = gtk_fixed_new ();
  
  gtk_widget_show (fixed2);
  gtk_container_add (GTK_CONTAINER (frame_search), fixed2);

  entry_search_name = gtk_entry_new ();
  
  gtk_widget_show (entry_search_name);
  gtk_fixed_put (GTK_FIXED (fixed2), entry_search_name, 56, 0);
  
  gtk_widget_set_usize (entry_search_name, 112, 30);

  label1 = gtk_label_new ("Nazwa :");
  
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (fixed2), label1, 2, 0);
  
  gtk_widget_set_usize (label1, 50, 28);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label1), TRUE);

  button_search_name = gtk_button_new_from_stock (GTK_STOCK_FIND);
  
  gtk_widget_show (button_search_name);
  gtk_fixed_put (GTK_FIXED (fixed2), button_search_name, 176, 0);
  
  gtk_widget_set_usize (button_search_name, 80, 32);
  gtk_signal_connect (GTK_OBJECT (button_search_name), "clicked", GTK_SIGNAL_FUNC (findStoreName), conn_mod);

  entry_search_id = gtk_entry_new ();
  
  gtk_widget_show (entry_search_id);
  gtk_fixed_put (GTK_FIXED (fixed2), entry_search_id, 328, 0);

  
  gtk_widget_set_usize (entry_search_id, 41, 30);

  button_search_id = gtk_button_new_from_stock (GTK_STOCK_FIND);
  
  gtk_widget_show (button_search_id);
  gtk_fixed_put (GTK_FIXED (fixed2), button_search_id, 376, 0);
  gtk_signal_connect (GTK_OBJECT (button_search_id), "clicked", GTK_SIGNAL_FUNC (findStoreId), conn_mod);
  
  gtk_widget_set_usize (button_search_id, 88, 32);

  label2 = gtk_label_new ("Numer ID :");

  
  gtk_widget_show (label2);
  gtk_fixed_put (GTK_FIXED (fixed2), label2, 262, 0);
  
  gtk_widget_set_usize (label2, 70, 28);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label2), TRUE);

  button_remove = gtk_button_new_from_stock (GTK_STOCK_DELETE);
  
  gtk_widget_show (button_remove);
  gtk_fixed_put (GTK_FIXED (fixed_main), button_remove, 8, 192);
  
  gtk_widget_set_usize (button_remove, 88, 32);
  gtk_signal_connect (GTK_OBJECT (button_remove), "clicked", GTK_SIGNAL_FUNC (removeStore), conn_mod);

  button_show_clist = gtk_button_new_from_stock (GTK_STOCK_INDEX);
  gtk_widget_show (button_show_clist);
  gtk_fixed_put (GTK_FIXED (fixed_main), button_show_clist, 8, 232);
  gtk_widget_set_usize (button_show_clist, 88, 32);
  gtk_signal_connect (GTK_OBJECT (button_show_clist), "clicked", GTK_SIGNAL_FUNC (showStoresClist), conn_mod);

  button_add = gtk_button_new_from_stock (GTK_STOCK_ADD);
  
  gtk_widget_show (button_add);
  gtk_fixed_put (GTK_FIXED (fixed_main), button_add, 400, 192);
  
  gtk_widget_set_usize (button_add, 88, 32);
  gtk_signal_connect (GTK_OBJECT (button_add), "clicked", GTK_SIGNAL_FUNC (addStore), conn_mod);

  button_update = gtk_button_new_with_label ("Uaktualnij");
  
  gtk_widget_show (button_update);
  gtk_fixed_put (GTK_FIXED (fixed_main), button_update, 400, 232);
  
  gtk_widget_set_usize (button_update, 88, 32);
  gtk_signal_connect (GTK_OBJECT (button_update), "clicked", GTK_SIGNAL_FUNC (updateStore), conn_mod);

  button_clean = gtk_button_new_from_stock (GTK_STOCK_CLEAR);
  
  gtk_widget_show (button_clean);
  gtk_fixed_put (GTK_FIXED (fixed_main), button_clean, 400, 272);
  
  gtk_widget_set_usize (button_clean, 88, 32);
  gtk_signal_connect (GTK_OBJECT (button_clean), "clicked", GTK_SIGNAL_FUNC (cleanStore), NULL);

  frame_stores = gtk_frame_new ("Magazyn");
  
  gtk_widget_show (frame_stores);
  gtk_fixed_put (GTK_FIXED (fixed_main), frame_stores, 8, 72);
  
  gtk_widget_set_usize (frame_stores, 479, 110);

  fixed3 = gtk_fixed_new ();
  
  gtk_widget_show (fixed3);
  gtk_container_add (GTK_CONTAINER (frame_stores), fixed3);

  entry_name = gtk_entry_new ();
  
  gtk_widget_show (entry_name);
  gtk_fixed_put (GTK_FIXED (fixed3), entry_name, 160, 8);
  
  gtk_widget_set_usize (entry_name, 304, 30);

  label3 = gtk_label_new ("Nazwa magazynu :");
  
  gtk_widget_show (label3);
  gtk_fixed_put (GTK_FIXED (fixed3), label3, 10, 8);
  
  gtk_widget_set_usize (label3, 140, 42);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label3), TRUE);

  label4 = gtk_label_new ("Opis magazynu :");
  
  gtk_widget_show (label4);
  gtk_fixed_put (GTK_FIXED (fixed3), label4, 10, 56);
  
  gtk_widget_set_usize (label4, 120, 32);
  gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label4), TRUE);

  entry_memo = gtk_entry_new ();
  
  gtk_widget_show (entry_memo);
  gtk_fixed_put (GTK_FIXED (fixed3), entry_memo, 160, 56);
  
  gtk_widget_set_usize (entry_memo, 304, 30);

  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_LEFT);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);
  gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_LEFT);

  }else{
    msg_struct.type = GTK_MESSAGE_WARNING;
    msg_struct.msg = g_string_new ("Najpierw musisz zalogować się !! \n\n\t XdeFactor-ng");
    xdfDialogMsg (&msg_struct);
    g_string_free (msg_struct.msg, TRUE);
  }

}
