#include "callbacks.h"
/*
 * http://developer.gnome.org/doc/API/2.0/pango/pango-Text-Processing.html
 * http://www-106.ibm.com/developerworks/linux/library/l-u-pango1/
 *	http://developer.gnome.org/doc/API/2.0/glib/glib-Character-Set-Conversion.html#g-locale-to-utf8
 *	
 * Funkcja konwertujca string do utf8 zgodnie z localami. Jeli lokale nie s
 * ustawione zakadane jest iso-8859-2.
 *
 */
char *conv_to_utf8(const char *str)
{
	gsize converted;
	char *utf8;

	if (str == NULL) {
		return NULL;
	}

	if (g_utf8_validate(str, -1, NULL)) {
		return g_strdup(str);
	}

	utf8 = g_locale_to_utf8(str, -1, &converted, NULL, NULL);
	if (utf8) 
		return(utf8);
	
	g_free(utf8);
	
	utf8 = g_convert(str, -1, "UTF-8", "ISO-8859-2", &converted, NULL, NULL);
	if (utf8 && converted == strlen (str)) {
		return(utf8);
	} else if (utf8) {
		g_free(utf8);
	}

	return(NULL);
}

